/** @file

Copyright (c) 2024, Intel Corporation. All rights reserved.<BR>

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice, this
  list of conditions and the following disclaimer in the documentation and/or
  other materials provided with the distribution.
* Neither the name of Intel Corporation nor the names of its contributors may
  be used to endorse or promote products derived from this software without
  specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
  THE POSSIBILITY OF SUCH DAMAGE.

  This file is automatically generated. Please do NOT modify !!!

**/

#ifndef __FSPT_UPD_H__
#define __FSPT_UPD_H__

#include <FspUpd.h>

#pragma pack(1)

typedef struct {

/** N/A
**/
  UINT64                      MicrocodeRegionBase;

/** N/A
**/
  UINT64                      MicrocodeRegionLength;

/** N/A
**/
  UINT64                      CodeRegionBase;

/** N/A
**/
  UINT64                      CodeRegionLength;

} FSPT_CORE_UPD;


typedef struct {

/**  Disable Port80 output in FSP-T
  0:VPD-Style, 1:Enable Port80 Output[Default], 2:Disable Port80 Output
**/
  UINT8                       FsptPort80RouteDisable;

/** N/A
**/
  UINT8                       ReservedTempRamInitUpd[31];

} FSPT_CONFIG;


typedef struct {

/** N/A
**/
  FSP_UPD_HEADER              FspUpdHeader;

/** N/A
**/
  FSPT_ARCH2_UPD              FsptArchUpd;

/** N/A
**/
  FSPT_CORE_UPD               FsptCoreUpd;

/** N/A
**/
  FSPT_CONFIG                 FsptConfig;

/** N/A
**/
  UINT16                      UpdTerminator;

} FSPT_UPD;

#pragma pack()

#endif
